
#ifndef filesys_h
#define filesys_h

#include "boolean.h"
//#include "unicode.h"

//#define MPCFIOTitle "GBAMP/AdMovie CFI/O"

//#define MPCFIOTitle0 "gbamp_cf.c By chishm"
//#define MPCFIOTitle1 "GBAMP CF I/O test r9 by SaTa."

//#define GBFSTitle "GBFS FlashCartLink"

#define FT_Path (0)
#define FT_File (1)

#define VT_NULL (0)
#define VT_IMFS (1)
#define VT_MPCF (2)
#define VT_GBFS (3)

#define MAX_PATH_LENGTH 1024	// Maximum length of the path to a file
#define MAX_FILENAME_LENGTH 256	// Maximum LFN length. Don't change this one

#ifdef __cplusplus
extern "C" {
#endif

extern u32 VolumeType;

void FileSys_Init(void);
void FileSys_Free(void);
void FileSys_RefreshVolume(void);
void FileSys_RefreshPath(void);
void FileSys_ChangePath(char *TargetPathName);
s32 FileSys_GetFileCount(void);
char* FileSys_GetPathName(void);
char* FileSys_GetAlias(s32 FileIndex);
//UnicodeChar* FileSys_GetFilename(s32 FileIndex);
char* FileSys_GetFilename(s32 FileIndex);
u32 FileSys_GetFileType(s32 FileIndex);
void FileSys_GetFileExt(s32 FileIndex,char *ext);
u32 FileSys_GetFileDataSize(u32 FileIndex);
b8 FileSys_GetFileData(u32 FileIndex,u8 *dstbuf);

int FileSys_fopen(u32 FileIndex);
b8 FileSys_fclose (int file);
long int FileSys_ftell (int file);
int FileSys_fseek(int file, u32 offset, int origin);
u32 FileSys_fread (void* buffer, u32 size, u32 count, int file);

void FileSys_SetPath(char *filename, s32 FileIndex);

void FileSys_SetFileInfo(void *FileInfo, s32 FileIndex);
void *FileSys_GetFilePtr(u32 size, u32 count, int file);

#ifdef __cplusplus
}	   // extern "C"
#endif

#endif

